import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import java.util.*;

public class SessionTracking extends DesignedHtmlServlet {
  private static final String CONTENT_TYPE = "text/html";

  public void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
    String userName = request.getParameter("name");
    String email =  request.getParameter("email");
    String  message = "";


    response.setContentType(CONTENT_TYPE);
    PrintWriter out = response.getWriter();
    StartOfHtml(out,"Simple Session Tracking");
    ExampleTitle(out, 8,"Simple Session Tracking - Access Count");

    boolean loginFailed = false;
    if (userName == null || userName.length() <=0) {
     loginFailed = true;
     message = "Incorerect login info : Missing user name";
    } else if (email == null || email.length() <= 0) {
     loginFailed = true;
     message = "Incorerect login info : Missing email";
    }
    if (loginFailed){
     out.println(message);
     EndOfHtml(out);
    } else {
   // create a new session if not already exists
     Integer accessCount;
     HttpSession session = request.getSession(true);

     if (session.isNew()) {
      accessCount = new Integer(0); // first time this servlet was accessed
      message = "Welcome "+ userName+ " for your first time\n"+
               " a login notification shall be shortly be sent to "+email;
     } else {
      // Use getAttribute instead of getValue in version 2.2.
      accessCount = (Integer)session.getValue("accessCount");
      if(accessCount==null){
        message="accessCount is NULL";
       }
      else {
             accessCount = new Integer(accessCount.intValue() + 1);
             message  = "Welcome back "+userName+ "\nThis is the "+accessCount+
                 " time you access this site";
        }
     }
    // Use setAttribute instead of putValue in version 2.2.
     session.putValue("accessCount", accessCount);
     out.println(message);
     EndOfHtml(out);
    }
  }

  /** Handle GET and POST requests identically. */

  public void doPost(HttpServletRequest request,
                     HttpServletResponse response)
      throws ServletException, IOException {
    doGet(request, response);
  }

}